<?php

class appGoogleProductCategoryBackendActions extends stAdminGeneratorActions{
     
    public function executeIndex(){
        
        $i18n = $this->getContext()->getI18N();

        $culture = $this->getUser()->getCulture();

        if ($culture == 'pl_PL')
        {
            $this->categories = array_replace(appGoogleProductCategory::$getGoogleProductCategoriesPl, array('none' => 'Ustaw indywidualnie'));
        }
        elseif ($culture == 'en_US')
        {
            $this->categories = array_replace(appGoogleProductCategory::$getGoogleProductCategoriesEn, array('none' => 'Set individually'));
        }

        $this->config = stConfig::getInstance('appGoogleProductCategoryBackend');

        $this->config->setCulture($this->getRequestParameter('culture', stLanguage::getOptLanguage()));
        
        if ($this->getRequest()->getMethod() == sfRequest::POST)
        {

            $this->config->set('enable_googlecategories', $this->getRequestParameter('googlecategories[enable_googlecategories]'));

            $this->config->set('main_category', $this->getRequestParameter('googlecategories[main_category]'));

            $this->config->save();

            if ($this->getRequestParameter('googlecategories[main_category]') != 'none') {

                $con = Propel::getConnection();
            
                $results = $con->executeQuery("UPDATE `st_category` SET `google_product_category` = '". $this->getRequestParameter('googlecategories[main_category]')."' WHERE `google_product_category` IS NULL;");  

            }

            stFastCacheManager::clearCache();
            
            $this->setFlash('notice', $i18n->__('Twoje zmiany zostały zapisane', null, 'stAdminGeneratorPlugin'));
            
            $this->redirect('appGoogleProductCategoryBackend/index?culture=' . $this->getRequestParameter('culture', stLanguage::getOptLanguage()));
        }
        
        $this->config->load();

        $this->getBreadcrumbs()->add($i18n->__('Konfiguracja', null, 'stAdminGeneratorPlugin'));

    }

    public function executeLoadCategories()
    {
        $id = $this->getRequestParameter('id');

        $culture = $this->getUser()->getCulture();

        if ($culture == 'pl_PL')
        {
            $culture = 'pl';
        }
        elseif ($culture == 'en_US')
        {
            $culture = 'en';
        }

        $categories = array();

        $data = file_get_contents(sfConfig::get('sf_upload_dir').'/google_product_category/'.$id.'_'.$culture.'.txt');
    
        $link_arr = explode("\n", $data);
        
        unset($link_arr[0]);

        foreach($link_arr as $cat)
        {
            if($cat)
            {
                $c = explode(" - ", $cat);
                $categories[] = array(
                    'id' => $c[0],
                    'label' => $c[1]
                );
            }
        }

        usort($categories, function($a, $b) {
             return strnatcmp($a['label'], $b['label']);
        });

        // die("<pre>".json_encode($categories)."</pre>");

        return $this->renderJSON($categories);
    }

    protected function getBreadcrumbs(){
        
        if (null === $this->breadcrumbs){
            $i18n = $this->getContext()->getI18N();
            $this->breadcrumbs = parent::getBreadcrumbs();
            $this->breadcrumbs->add($i18n->__('Kategorie Google'), '@appGoogleProductCategoryPlugin');
        }

        return $this->breadcrumbs;
    }
    
}